#include <tos.h>

#define x_max 2048

struct
{ unsigned int		colnums;
  unsigned int		lines;
}			header;

struct 
{ int			line_number;
  char			line [ x_max * 3 ];
}			input;

char 			output [ x_max * 3 ];

int main ( int argc, const char *argv[] )

{ int			input_file;
  int			output_file;
  long			input_length;

  if ( argc != 3 ) return 1;
   
  input_file		= Fopen   ( argv[1], FO_READ );
  if ( input_file < 0 ) return 2;
  output_file		= Fcreate ( argv[2], 0 );
  input_length		= Fseek ( 0, input_file, 2);
  Fseek ( 0, input_file, 0 );
  Fread ( input_file, sizeof ( header ), &header );
  
  header.colnums 	= header.colnums / 256
			+ ( header.colnums % 256 ) * 256;

  while (1)
    { long		read_length
			= Fread 
			( input_file, 
			  2+3 * header.colnums,
			  &input );
      if ( read_length	== 0 )
	break;
      { char			*to_output 
				=  &output [0];
	int			x;
	for ( x = 0; x < x_max; x++ )
	  { *to_output++ 	= input.line 
				[ x ];
	    *to_output++ 	= input.line 
				[ x + header.colnums ];
	    *to_output++	= input.line 
				[ x + 2 * header.colnums ];	  
	  }
	Fwrite ( output_file, header.colnums * 3, &output );
      }
    } 

  Fclose ( input_file );
  Fclose ( output_file );
  return 0;
}